#include "DxLib.h"
#include <math.h>

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int GradTexHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float LightRotateAngle ;
	int AnimIndex ;
	float AnimCounter ;
	int DirLightHandle ;
	int PointLightHandle ;
	int SpotLightHandle ;
	VECTOR LightPosition ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}


	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "SkinMesh4_DirSpotPointLight_Toon_PhongVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "SkinMesh4_DirSpotPointLight_Toon_PhongPS.pso" ) ;


	// Of[VeNX`ǂݍ
	GradTexHandle = LoadGraph( "GradTex.bmp" ) ;

	// XLjObVfǂݍ
	ModelHandle = MV1LoadModel( "DxChara.x" ) ;

	// ₷悤ɕ̃}eAΐFɂ
	MV1SetMaterialDifColor( ModelHandle, 1, GetColorF( 0.0f, 0.5f, 0.0f, 1.0f ) ) ;


	// Aj[VOA^b`
	AnimIndex = MV1AttachAnim( ModelHandle, 0 ) ;

	// Aj[VJE^Zbg
	AnimCounter = 0.0f ;


	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gpeNX`PɃOf[VeNX`Zbg
	SetUseTextureToShader( 1, GradTexHandle ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;


	// WCgItɂ
	SetLightEnable( FALSE ) ;

	// fBNViCg쐬
	DirLightHandle = CreateDirLightHandle( VGet( 1.0f, 0.0f, 0.0f ) ) ;

	// |CgCgnh쐬
	PointLightHandle = CreatePointLightHandle( VGet( 0.0f, 0.0f, 0.0f ), 1000.0f, 0.86f, 0.0000f, 0.0000f ) ;

	// X|bgCg쐬
	SpotLightHandle = CreateSpotLightHandle( VGet( 0.0f, 0.0f, 0.0f ), VGet( 0.0f, -1.0f, 0.0f ), 0.7f, 0.6f, 1000.0f, 0.391586f, 0.001662f, 0.0f ) ;

	// X|bgCg̃ArGgJ[𖳌ɂ
	SetLightAmbColorHandle( SpotLightHandle, GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ) ;

	// X|bgCg̃fBt[YJ[΂ɂ
	SetLightDifColorHandle( SpotLightHandle, GetColorF( 0.0f, 1.0f, 0.0f, 0.0f ) ) ;

	// Cg̈ʒu]l
	LightRotateAngle = 0.0f ;


	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f̌ʒuɃJzu
	SetCameraPositionAndTarget_UpVecY( VGet( 0.0f, 700.0f, -1100.0f ), VGet( 0.0f, 350.0f, 0.0f ) ) ;


	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// |CgCg̈ʒủ]lZ
		LightRotateAngle += 0.02f ;

		// |CgCg̈ʒu̍XV
		LightPosition.x = sin( LightRotateAngle ) * 600.0f ;
		LightPosition.y = 400.0f ;
		LightPosition.z = cos( LightRotateAngle ) * 600.0f - 250.0f ;
		SetLightPositionHandle( PointLightHandle, LightPosition ) ;

		// X|bgCg̈ʒu̍XV
		LightPosition.x = 0.0f ;
		LightPosition.y = cos( LightRotateAngle ) * 700.0f + 400.0f ;
		LightPosition.z = sin( LightRotateAngle ) * 700.0f - 250.0f ;
		SetLightPositionHandle( SpotLightHandle, LightPosition ) ;

		// Cǧ]Sɂ
		SetLightDirectionHandle( SpotLightHandle, VSub( VGet( 0.0f, 400.0f, -250.0f ), LightPosition ) ) ;

		// Aj[VԂi߂
		AnimCounter += 100.0f ;
		if( AnimCounter > MV1GetAnimTotalTime( ModelHandle, 0 ) )
		{
			AnimCounter -= MV1GetAnimTotalTime( ModelHandle, 0 ) ;
		}
		MV1SetAttachAnimTime( ModelHandle, AnimIndex, AnimCounter ) ;

		// f`
		MV1DrawModel( ModelHandle ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// fBNViCg̍폜
	DeleteLightHandle( DirLightHandle ) ;

	// X|bgCg̍폜
	DeleteLightHandle( SpotLightHandle ) ;

	// |CgCg̍폜
	DeleteLightHandle( PointLightHandle ) ;

	// gpeNX`Of[VeNX`O
	SetUseTextureToShader( 1, -1 ) ;

	// Of[VeNX`폜
	DeleteGraph( GradTexHandle ) ;

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
